`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    05:42:47 04/18/2016 
// Design Name: 
// Module Name:    keypad_fsm 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define STAT_NUM1 2'b10
`define STAT_NUM2 2'b11
`define STAT_RESULT 2'b01
`define STAT_RESET 2'b00
`define DISP_INPUT 1'b0;
`define DISP_RESULT 1'b1
`define RST 2'b00
`define ADD 2'b01
`define SUB 2'b10
`define KEY_A  4'd10 // key 'A'
`define KEY_B  4'd11 // key 'B'
`define KEY_E  4'd14 // key 'E'
module keypad_fsm(
   clk,
	rst_n,
	add,
	sub,
	eq,
	key,
	pressed,
	num1,
	num2,
	state,
	state_display,
	calculation
	);

	input clk, rst_n;
	input add, sub, eq;
	input [3:0] key;
	input pressed;

	output reg [7:0] num1;
	output reg [7:0] num2;
	output reg [1:0] calculation;
	output reg state_display;
	output reg [1:0] state;

	reg [1:0] state_next;


	always @(posedge pressed)
		case(state)
		`STAT_NUM1:
			begin
			if(~rst_n)
				begin
				state_next = `STAT_NUM1;
				state_display = `DISP_INPUT;
				calculation = `RST;
				num1 <= 8'd0; 
				num2 <= 8'd0;
				end
			else if(key == `KEY_A)
				begin
				state_next = `STAT_NUM2;
				state_display = `DISP_INPUT;
				calculation = `ADD;
				end
			else if(key == `KEY_B)
				begin
				state_next = `STAT_NUM2;
				state_display = `DISP_INPUT;
				calculation = `SUB;
				end
			else
				begin
				state_next = `STAT_NUM1;
				state_display = `DISP_INPUT;
				num1[7:4] <= num1[3:0]; 
				num1[3:0] <= key; 
				num2 <= num2;
				end
			end
			
		`STAT_NUM2:
			begin
			if(~rst_n)
				begin
				calculation = `RST;
				state_next = `STAT_NUM1;
				state_display = `DISP_INPUT;
				num1 <= 8'd0; 
				num2 <= 8'd0;
				end
			else if(key == `KEY_E)
				begin
				state_next = `STAT_RESULT;
				state_display = `DISP_RESULT;
				end
			else
				begin
				state_next = `STAT_NUM2;
				state_display = `DISP_INPUT;
				num2[7:4] <= num2[3:0]; 
				num2[3:0] <= key; 
				num1 <= num1;
				end
			end
			
		`STAT_RESULT:
			begin
				if(~rst_n)
				begin
				calculation = `RST;
				state_next = `STAT_NUM1;
				state_display = `DISP_INPUT;
				num1 <= 8'd0; 
				num2 <= 8'd0;
				end
				else
				begin
				state_next = `STAT_RESULT;
				state_display = `DISP_RESULT;
				end
			end
				
		`STAT_RESET:
			begin
				state_next = `STAT_NUM1;
			end				
			
			default:
				begin
				state_next = `STAT_NUM1;
				end
			endcase
				
	always @(posedge clk or negedge rst_n)
		if(~rst_n)
			state <= `STAT_NUM1;
		else
			state <= state_next;



endmodule
