`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    05:42:17 04/18/2016 
// Design Name: 
// Module Name:    lab06_3 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
	module lab06_3(
   clk,
	rst_n,
	col_n,
	row_n,
	display
);

	input clk,rst_n;
	input [3:0] col_n;
	output [3:0] row_n;
	output [18:0] display;
	wire [1:0] clk_ctl;
	wire clk_d;
	wire [3:0] key;
	wire pressed;
	
	wire [1:0] cal_state;
	wire [1:0] state_num_input;
	wire [7:0] num1, num2;
	wire [7:0] equal;
	wire [11:0] result;
	wire [14:0] sign;
	
	wire [29:0] num1_FTSD, num2_FTSD;
	wire [44:0] result_FTSD;
	wire [14:0] sign_FTSD;
	
	wire state_display;
	wire [14:0] display1, display2, display3, display4;
	wire pb_rst, op_rst;

	freq_div U1(
		.clk_ctl(clk_ctl),
		.clk(clk),
		.rst_n(rst_n),
		.clk_out(clk_d)
	);

	one_pulse U2(
	  .clk(clk_d),  
	  .rst_n(rst_n), 
	  .in_trig(rst_n), 
	  .out_pulse(op_rst)  
	);

	debounce_circuit U3(
	  .clk(clk_d), 
	  .rst_n(rst_n), 
	  .pb_in(op_rst), 
	  .pb_debounced(pb_rst) 
	);


	keypad_scan U4(
		.clk(clk_d),
		.rst_n(rst_n),
		.row_n(row_n),
		.col_n(col_n),
		.key(key),
		.pressed(pressed)
	);

	keypad_fsm U5(
		.clk(clk_d),
		.rst_n(pb_rst),
		.add(pb_add),
		.sub(pb_sub),
		.eq(pb_eq),
		.key(key),
		.pressed(pressed),
		.num1(num1),
		.num2(num2),
		.state_display(state_display),
		.calculation(cal_state)
	);

	num_calculator U6(
		.num1(num1),
		.num2(num2),
		.cal_state(cal_state),
		.equal(equal),
		.sign(sign)
	);

	BIN_converter_BCD U7(
		.in(equal),
		.unit(result[3:0]),
		.ten(result[7:4]),
		.hund(result[11:8])
	);

	ftsd U8_NUM1_1(
		.display(num1_FTSD[14:0]),
		.num(num1[3:0])
	);

	ftsd U9_NUM1_2(
		.display(num1_FTSD[29:15]),
		.num(num1[7:4])
	);

	ftsd U10_NUM2_1(
		.display(num2_FTSD[14:0]),
		.num(num2[3:0])
	);

	ftsd U11_NUM2_2(
		.display(num2_FTSD[29:15]),
		.num(num2[7:4])
	);

	ftsd U12_RESULT_1(
		.display(result_FTSD[14:0]),
		.num(result[3:0])
	);

	ftsd U13_RESULT_2(
		.display(result_FTSD[29:15]),
		.num(result[7:4])
	);

	ftsd U14_RESUT_3(
		.display(result_FTSD[44:30]),
		.num(result[11:8])
	);

	ftsd_ctl U15(
		.state(state_display),
		.rst_n(rst_n),
		.num1_FTSD(num1_FTSD),
		.num2_FTSD(num2_FTSD),
		.sign_FTSD(sign),
		.result_FTSD(result_FTSD),
		.display1(display1),
		.display2(display2),
		.display3(display3),
		.display4(display4)
	);

	scan_ctl U16(
		.in1(display1),
		.in2(display2),
		.in3(display3),
		.in4(display4),
		.clk_ctl(clk_ctl),
		.display(display)
	);


endmodule
