`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:23:22 04/18/2016 
// Design Name: 
// Module Name:    num_calculator 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define RST 2'b00
`define ADD 2'b01
`define SUB 2'b10
module num_calculator(
   num1,
	num2,
	equal,
	sign,
	cal_state
	);

	input [7:0] num1, num2;
	input [1:0] cal_state;

	output reg [7:0] equal;
	output reg [14:0] sign;
		
	wire [7:0] bin1, bin2;

	// convert BCD to binary (from internet)	
	assign bin1 = num1[7:4]*4'd10 + num1[3:0];
	assign bin2 = num2[7:4]*4'd10 + num2[3:0];
		
	always @*
		if(cal_state == `ADD)
			begin
			equal = bin1+bin2;
			sign = 15'b1111_1111_1111_111;
			end
		else if(cal_state == `SUB && bin1 < bin2)
		begin
			equal = ~(bin1-bin2-1'b1);
			sign = 15'b1111_1100_1111_111;
			end
		else if(cal_state == `SUB && bin1 >= bin2)
			begin
			equal = bin1-bin2;
			sign = 15'b1111_1111_1111_111;
			end


endmodule
